/*
	Indici non utilizzati (o poco utilizzati)
*/

SELECT OBJECT_SCHEMA_NAME(i.object_id), OBJECT_NAME(i.object_id), i.index_id, i.name, 
	iu.user_seeks, iu.user_scans, iu.user_lookups, iu.user_updates 
FROM sys.indexes i LEFT JOIN sys.dm_db_index_usage_stats iu
		ON i.object_id = iu.object_id
			AND i.index_id = iu.index_id
			AND database_id = DB_ID()
WHERE i.object_id > 1000
	AND ISNULL(iu.user_seeks, 0) + ISNULL(iu.user_scans, 0) + ISNULL(iu.user_lookups, 0) < 4
	AND OBJECT_SCHEMA_NAME(i.object_id) <> 'sys'
ORDER BY 1, 2


/*
	...su tabelle con 0 righe
*/

SELECT OBJECT_NAME(object_id), * 
FROM sys.dm_db_index_physical_stats (DB_ID(), NULL, NULL, NULL, 'SAMPLED')
WHERE object_id > 1000
	AND record_count = 0
	AND index_id < 2
	AND object_id NOT IN (	
				SELECT object_id 
				FROM sys.dm_db_index_usage_stats
				WHERE database_id = DB_ID()
					AND object_id > 1000
					AND user_seeks + user_scans + user_lookups + user_updates > 0)	
ORDER BY 1
