USE AdventureWorks2012;
GO


/*
	Identificare gli indici utilizzati
*/

SELECT OBJECT_SCHEMA_NAME(object_id), OBJECT_NAME(object_id), * 
FROM sys.dm_db_index_usage_stats
WHERE database_id = DB_ID()

SELECT * FROM Person.Address

SELECT * FROM Person.Address
WHERE StateProvinceID = 11

SELECT * FROM Person.Address
WHERE AddressID = 99999

SELECT * FROM sys.dm_db_index_usage_stats
WHERE database_id = DB_ID()


/*
	Ultimo accesso alle tabelle
*/

SELECT TABLE_SCHEMA, TABLE_NAME,
	(SELECT MAX(v) FROM (VALUES (lastseek), (lastscan), (lastlookup)) AS r(v)) as lastread, 
	lastupdate
FROM INFORMATION_SCHEMA.TABLES T LEFT JOIN
	(
	SELECT OBJECT_SCHEMA_NAME(object_id) sch, OBJECT_NAME(object_id) tab, 
		MAX(last_user_seek) lastseek, MAX(last_user_scan) lastscan, 
		MAX(last_user_lookup) lastlookup, MAX(last_user_update) lastupdate
	FROM sys.dm_db_index_usage_stats
	WHERE database_ID = DB_ID()
	GROUP BY OBJECT_SCHEMA_NAME(object_id), OBJECT_NAME(object_id)
	) iu ON T.TABLE_SCHEMA = iu.sch
			AND T.TABLE_NAME = iu.tab
WHERE TABLE_TYPE = 'BASE TABLE'
ORDER BY 1, 2


/*
	Tabelle mai accedute
*/

SELECT TABLE_SCHEMA, TABLE_NAME
FROM INFORMATION_SCHEMA.TABLES T LEFT JOIN
	(
	SELECT OBJECT_SCHEMA_NAME(object_id) sch, OBJECT_NAME(object_id) tab, 
		MAX(last_user_seek) lastseek, MAX(last_user_scan) lastscan, 
		MAX(last_user_lookup) lastlookup, MAX(last_user_update) lastupdate
	FROM sys.dm_db_index_usage_stats
	WHERE database_ID = DB_ID()
	GROUP BY OBJECT_SCHEMA_NAME(object_id), OBJECT_NAME(object_id)
	) iu ON T.TABLE_SCHEMA = iu.sch
			AND T.TABLE_NAME = iu.tab
WHERE TABLE_TYPE = 'BASE TABLE'
	AND lastseek IS NULL AND lastscan IS NULL AND lastlookup IS NULL AND lastupdate IS NULL
ORDER BY 1, 2


