/*
	Creare un ENDPOINT
*/

IF EXISTS (SELECT 1 FROM sys.server_principals WHERE name = 'Luca')
	DROP LOGIN Luca
GO

CREATE LOGIN Luca WITH PASSWORD = 'Milagro:1';
GO

IF EXISTS (SELECT * FROM sys.endpoints WHERE name = 'EPxLuca')
	DROP ENDPOINT EPxLuca
GO

CREATE ENDPOINT EPxLuca
STATE = STARTED
AS TCP (
	LISTENER_PORT = 2433,
	LISTENER_IP = ALL)
FOR TSQL ();
GO

GRANT CONNECT ON ENDPOINT::[TSQL Default TCP] TO public;
GO

DENY CONNECT ON ENDPOINT::[TSQL Default TCP] TO Luca;
GO

GRANT CONNECT ON ENDPOINT::[EPxLuca] TO Luca;
GO


/*
	Chi ha permessi sui rispettivi EP?
*/

SELECT endp.name AS endpoint, perm.permission_name AS permission, 
	perm.state_desc AS state, prin.name AS principal, 
	CASE tcp.port WHEN 0 THEN 1433 ELSE tcp.port END AS port --, * 
FROM sys.server_permissions AS perm INNER JOIN sys.server_principals AS prin
		ON perm.grantee_principal_id = prin.principal_id
	INNER JOIN sys.endpoints endp 
		ON perm.major_id = endp.endpoint_id
	LEFT JOIN sys.tcp_endpoints tcp 
		ON endp.endpoint_id = tcp.endpoint_id
WHERE perm.class_desc = 'ENDPOINT'
	AND endp.protocol_desc = 'TCP'

