/*
	TRANSPARENT DATA ENCRYPTION - SETUP
	
	1 - Creazione della MASTER KEY (master)
	2 - Creazione del certificato (master)
	3 - Database Encryption Key (database)
	4 - ALTER DATABASE database SET ENCRYPTION ON
*/

USE master;
GO

IF EXISTS (SELECT 1 FROM sys.certificates WHERE name = 'ServerCert')
	DROP CERTIFICATE ServerCert
GO

/*
	ATTENZIONE: 
	La MK del master potrebbe proteggere 
	altri certificati (es: db mirroring)
*/

IF EXISTS(SELECT 1 FROM sys.symmetric_keys WHERE symmetric_key_id = 101)
	DROP MASTER KEY
GO

--Definizione della Database Master Key nel master
IF NOT EXISTS (SELECT 1 FROM sys.symmetric_keys WHERE symmetric_key_id = 101)
	CREATE MASTER KEY ENCRYPTION BY PASSWORD = 'Sc7\n>qp*X0?@';
GO

--Creazione del certificato
--Attenzione: per default start_date  GETUTCDATE() e expiry date  un anno dopo
CREATE CERTIFICATE ServerCert WITH SUBJECT = 'Certificate for TDE - AdventureWorksLT2012';
GO

--SELECT * FROM sys.certificates


USE AdventureWorksLT2012;
GO

--Creazione DEK
CREATE DATABASE ENCRYPTION KEY
WITH ALGORITHM = AES_256
ENCRYPTION BY SERVER CERTIFICATE ServerCert
GO

--Info sullo status (encryption_state e percent_complete)
--SELECT DB_NAME(database_id), * FROM sys.dm_database_encryption_keys

--Abilitare l'encryption
ALTER DATABASE AdventureWorksLT2012 SET ENCRYPTION ON;
GO

--Il processo di encryption  asincrono
--Anche il tempdb (database_id=2) viene cifrato
--per assicurare che anche gli oggetti temporanei siano protetti
--encryption_state indica lo status di compressione (3=encrypted)
--SELECT * FROM sys.dm_database_encryption_keys;
--GO

USE master;
GO

--BACKUP DATABASE AdventureWorksLT2012 TO DISK = 'D:\Backup\AdventureWorksLT2012.bak' WITH INIT, FORMAT, COMPRESSION;
--GO

--BACKUP CERTIFICATE ServerCert TO FILE = 'D:\Backup\ServerCert.cer'
--WITH PRIVATE KEY 
--      ( FILE = 'D:\Backup\ServerCert.pvk',
--        ENCRYPTION BY PASSWORD = 'sldkflk3;4et6gs%53#v00' );
--GO
